<template>
  <div>
    <div v-if="canModify" class="text-right mb-4">
      <b-button @click="newTemplate" variant="info">
        <font-awesome-icon :icon="['fas', 'plus']" />
      </b-button>
    </div>

    <div
      v-for="tpl in templates"
      :key="tpl.id"
      class="row striped to-stripe mt-2 pt-1 pb-1"
    >
      <div v-if="canTranslate" class="col-1">
        <b-button
          :to="
            localePath({
              name: translatePage,
              params: { id: tpl.id },
            })
          "
          variant="primary"
        >
          TRANSLATE
        </b-button>
      </div>

      <div class="col-3">
        <div style="font-size: large;">
          {{ tpl.name }}
          <TemplateTypeBadge :type="tpl.type"></TemplateTypeBadge>
        </div>
        <div style="font-size: small;">(key: {{ tpl.slug }})</div>
      </div>

      <div class="col-3">
        <span
          v-for="lang in tpl.enabledLanguages"
          :key="lang"
          :class="{ 'font-weight-bold': lang === tpl.defaultLanguage }"
          class="mr-2"
          >{{ lang }}</span
        >
      </div>

      <div v-if="canModify" class="col text-right">
        <b-button @click="editTemplate(tpl)" variant="success"
          ><font-awesome-icon :icon="['fas', 'pencil-alt']"
        /></b-button>
        <b-button
          :to="
            localePath({
              name: brickPage,
              params: { id: tpl.id },
            })
          "
          variant="light"
        >
          EDIT BRICKS
        </b-button>
        <b-button @click="askRelease(tpl)" variant="warning">RELEASE</b-button>
        <b-button @click="askDelete(tpl)" variant="danger">
          <font-awesome-icon :icon="['fas', 'trash']" />
        </b-button>
      </div>
    </div>

    <TemplateEditModal
      ref="templateEditModal"
      @save="saveTemplate"
    ></TemplateEditModal>
  </div>
</template>

<script>
import TemplateTypeBadge from './badge/TemplateTypeBadge';
import TemplateEditModal from './template/TemplateEditModal';
export default {
  components: {
    TemplateTypeBadge,
    TemplateEditModal,
  },
  props: {
    apiBaseUrl: {
      type: String,
      required: true,
    },
    translatePage: {
      type: String,
      required: true,
    },
    brickPage: {
      type: String,
      required: true,
    },
    canTranslate: {
      type: Boolean,
      default: true,
    },
    canModify: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    return {
      templates: [],
    };
  },
  mounted() {
    this._loadData();
  },
  methods: {
    async _loadData() {
      const loader = this.$loading.show();

      const result = await this.$axios
        .$get(
          `${this.apiBaseUrl}/translator/template?pageNumber=0&pageSize=9999999`
        )
        .catch((err) => {
          alert(err);
        });

      this.templates = result.content;

      loader.hide();
    },
    askDelete(tpl) {
      this.$bvModal
        .msgBoxConfirm('Are you sure?', { centered: true })
        .then((value) => {
          if (value === true) {
            this.doDelete(tpl);
          }
        })
        // eslint-disable-next-line handle-callback-err
        .catch((err) => {
          // An error occurred
        });
    },
    askRelease(tpl) {
      this.$bvModal
        .msgBoxConfirm('Are you sure?', { centered: true })
        .then((value) => {
          if (value === true) {
            this.doRelease(tpl);
          }
        })
        // eslint-disable-next-line handle-callback-err
        .catch((err) => {
          // An error occurred
        });
    },
    async doRelease(tpl) {
      const loader = this.$loading.show();

      await this.$axios
        .$put(`${this.apiBaseUrl}/admin/template/${tpl.id}/release`)
        .catch((err) => {
          alert(err);
        });

      loader.hide();

      this._loadData();
    },
    async doDelete(tpl) {
      const loader = this.$loading.show();

      await this.$axios
        .$delete(`${this.apiBaseUrl}/admin/template/${tpl.id}`)
        .catch((err) => {
          alert(err);
        });

      loader.hide();

      this._loadData();
    },
    editTemplate(tpl) {
      this.$refs.templateEditModal.show(tpl);
    },
    newTemplate() {
      this.$refs.templateEditModal.show();
    },
    async saveTemplate(tpl) {
      const loader = this.$loading.show();

      if (tpl.id) {
        await this.$axios
          .$put(`${this.apiBaseUrl}/admin/template/${tpl.id}`, tpl)
          .catch((err) => {
            alert(err);
          });
      } else {
        await this.$axios
          .$post(`${this.apiBaseUrl}/admin/template`, tpl)
          .catch((err) => {
            alert(err);
          });
      }

      loader.hide();

      this._loadData();
    },
  },
};
</script>
